﻿var gridManager = null, refreshFlag = false,istoolbar=true;
//定义控件列
const bom=
	[
	{ display: "物料", name: "materialName", width: 140, minWidth: 60, type: "string", align: "left" },
		{ display: "物料数量", name: "materialNumber", width: 120, minWidth: 60, type: "string", align: "left" },
		{ display: "产品", name: "productId", width: 120, minWidth: 60, type: "string", align: "left" }
	]
const technology=[
	{ display: "工艺", name: "materialId", width: 140, minWidth: 60, type: "string", align: "left", hidden: true  }
]
const process=[
	{ display: "工序内容", name: "materialId", width: 140, minWidth: 60, type: "string", align: "left", hidden: true  },
	{ display: "工序名称", name: "materialName", width: 140, minWidth: 60, type: "string", align: "left" },
	{ display: "工序说明", name: "materialNumber", width: 120, minWidth: 60, type: "string", align: "left" },
	{ display: "工序类别", name: "materialNumber", width: 120, minWidth: 60, type: "string", align: "left" },
	{ display: "工时", name: "productName", width: 120, minWidth: 60, type: "string", align: "left" }
]
const processBom=[
	{ display: "物料", name: "materialId", width: 140, minWidth: 60, type: "string", align: "left", hidden: true  },
	{ display: "SAP物料详细信息", name: "materialName", width: 140, minWidth: 60, type: "string", align: "left" },
	{ display: "使用的物料数量", name: "materialNumber", width: 120, minWidth: 60, type: "string", align: "left" },
	{ display: "物料计量单位", name: "productName", width: 120, minWidth: 60, type: "string", align: "left" }
]


$(document).ready(function() {
	initializateUI();
	loadOrgTreeView();
	bindQueryEvent();
	loadProofingApplyGrid(null,bom,"mobTableGrid","");//加载BOm
	loadProofingApplyGrid(null,technology,"technologyGrid","");//加载工艺
	loadProofingApplyGrid(null,process,"processGrid","");//加载工序
	loadProofingApplyGrid(null,processBom,"processBomGrid","");//加载物料
	echo("productId");
	echo("productType")
});


function echo(node){
	$("#"+node+"_text").val($("#"+node).val())
}


//工艺、工序、工序物料三级联动
function test(){

}


function initializateUI() {
	UICtrl.layout("#layout", {leftWidth: 3});

}




//创建表格（参数、列、插入的节点、请求地址）
function loadProofingApplyGrid(param,columns,node,url) {


	const toolbarOptions = istoolbar
		? UICtrl.getDefaultToolbarOptions({
			addHandler: addHandler,
			updateHandler() {
				updateHandler();
			},
			deleteHandler: deleteHandler,
		})
		: null;
	istoolbar = false;


	gridManager =  UICtrl.grid("#"+node, {
		columns: columns,
		dataAction: "server",
		url: web_app.name + '/proofingApply/'+url+'.ajax',
		parms:param,
		pageSize: 10,
		usePager: true,
		toolbar: toolbarOptions,
		width: "100%",
		height: "50%",
		heightDiff: -8,
		checkbox: true,
		fixedCellHeight: true,
		selectRowButtonOnly: true,
		//双击行响应事件
		onDblClickRow : function(data, rowindex, rowobj) {
			updateHandler(data.id);
		}
	});
	UICtrl.setSearchAreaToggle(gridManager);
}

function loadOrgTreeView() {
	//ssrfOrgRootId hxPurchaseCommon.js
	$('#orgTree').commonTree({
		loadTreesAction:'org/queryOrgs.ajax',
		parentId :ssrfOrgRootId,
		getParam : function(e){
			return {showDisabledOrg:0,displayableOrgKinds : "ogn,dpt"};
		},
		changeNodeIcon:function(data){
			data[this.options.iconFieldName]= OpmUtil.getOrgImgUrl(data.orgKindId, data.status);
		},
		IsShowMenu:false,
		onClick :onFolderTreeNodeClick
	});
}

function onFolderTreeNodeClick(data) {
	var html=[];
	html.push('<span class="tomato-color">[',data.name,']</span>','编号规则管理');
	$('#layout').layout('setCenterTitle',html.join(''));
	$('#treefullId').val(data.fullId);
	if (gridManager) {
		UICtrl.gridSearch(gridManager,{fullId:data.fullId});
	}
}
//绑定selectC
function bindQueryEvent(){
	$('#productId').searchbox({
		type : "product",name : "productCode",
		onChange:function(value,data){
			$('#productId').val(data.productId);
			loadProofingApplyGrid({id:data.productId},bom,"mobTableGrid","slicedQueryBomRule");
		}
	});

	// $('#productType').searchbox({
	// 	type : "product",name : "productType",
	// 	onChange:function(value,data){
	// 		$('#productType').val(data.productCategoryId);
	//
	// 		console.log($('#productType').val())
	// 	}
	// });

}
function query(obj) {
	var param = $(obj).formToJSON();
	UICtrl.gridSearch(gridManager, param);
}

function reloadGrid() {
	gridManager.loadData();
}

function resetForm(obj) {
	$(obj).formClean();
}

function updateHandler(id){
	if(!id){
		var id = DataUtil.getUpdateRowId(gridManager);
		if (!id){ return; }
	}
	UICtrl.showAjaxDialog({
		url: web_app.name + '/codeRule/showLoadCodeRule.load',
		title: "修改BOM",
		width: 340,
		param:{id:id},
		ok: function(div){
			var _self=this;
			$('#submitForm',div).ajaxSubmit({url: web_app.name + '/codeRule/updateCodeRule.ajax',
				success : function() {
					_self.close();
					reloadGrid();
				}
			});
		}
	});
}

// 查询
function query(obj) {
	var param = $(obj).formToJSON();
	UICtrl.gridSearch(gridManager, param);
}

//刷新表格
function reloadGrid() {
	gridManager.loadData();
}

//重置表单
function resetForm(obj) {
	$(obj).formClean();
}

//关闭对话框
function dialogClose(){
	if(refreshFlag){
		reloadGrid();
		refreshFlag=false;
	}
}

//添加按钮
function addHandler() {
	UICtrl.showAjaxDialog({
		title: $.i18nProp('添加BOM'),
		url : web_app.name + '/proofingApply/forwardAddBom.load',
		ok : insert,
		width : 600,
		close : dialogClose
	});
}

//新增保存
function insert() {
	var _self=this;
	$('#submitDetailForm').ajaxSubmit({
		url : web_app.name + '/resourceField/saveResourceFiledValue.ajax',
		param:{},
		success : function(data) {
			if (data == "1"){
				Public.successTip("保存成功！");
			}
			_self.close();
			reloadGrid();
		}
	});
}

//编辑按钮
function updateHandler(id) {
	if (!id) {
		//获取所选行id
		id = DataUtil.getUpdateRowId(gridManager);
		if (!id) {
			return;
		}
	}
	UICtrl.showAjaxDialog({
		title: $.i18nProp('更新Bom'),
		width: 600,
		url: web_app.name + '/proofingApply/forwardAddBom.load',
		param: {id: id,resourceTypeId: $('#resourceTypeId').val()},
		ok: update,
		close:dialogClose
	});
}

//编辑保存
function update() {
	var _self=this;
	$('#submitDetailForm').ajaxSubmit({
		url : web_app.name + '/proofingApply/updateResourceFiledValue.ajax',
		success : function(data) {
			if (data == "1"){
				Public.successTip("修改成功！");
			}
			refreshFlag = true;
			_self.close();
			reloadGrid();
		}
	});
}

//删除按钮
function deleteHandler() {
	DataUtil.del({
		action: 'resourceField/deleteResourceFiledValue.ajax',
		param:{
			id:DataUtil.getUpdateRowId(gridManager),
			resourceTypeId: $('#resourceTypeId').val()
		},
		gridManager: gridManager, idFieldName: 'id',
		onSuccess: function (data) {
			if (data == "1"){
				Public.successTip("删除成功！");
			}
			reloadGrid();
		}
	});
}

//值改变刷新BOM
// function productIdSelectChange(){
// 	console.log("jiaz")
// 	$('#productCode_text').on('change', function() {
// 		// 获取输入框的当前值
// 		var currentValue = $(this).val();
// 		console.log("change触发")
// 		// 打印到控制台
// 		console.log('Input value changed:', currentValue);
// 	});
// 	// $("#productCode_text").change(function () {
// 	// 	console.log("change触发")
// 	// 	loadCodeRuleListGrid(this.productId);
// 	// });
//  }

/**
 * 流程引擎回调设置打样的id
 * @param value 打样申请的id
 */
function setId(proofingApplyId) {
	$("#proofingApplyId").val(proofingApplyId);
	// 为文件上传控件绑定业务id
}

/**
 * 流程引擎获取打样申请id的回掉方法。
 * @return 打样申请的id
 */
function getId() {
	return $("#proofingApplyId").val() || "";
}